<?php

// 主參考 https://www.wpeka.com/make-custom-endpoints-wordpress-rest-api.html

class TP_PAC_Server extends WP_REST_Controller {
 
  //The namespace and version for the REST SERVER
  var $my_namespace = 'tppac/v';
  var $my_version   = '1';
 
  public function register_routes() {
    $namespace = $this->my_namespace . $this->my_version;
    $base      = 'update';
    register_rest_route( $namespace, '/' . $base, array(
    array(
          'methods'         => WP_REST_Server::CREATABLE,	// POST, PUT, PATCH
          'callback'        => array( $this, 'update_password' ),
		  'permission_callback'   => array( $this, 'update_password_permission' )
    )
    )  );
  }
 
  // Register our REST Server
  public function hook_rest_server() {
    add_action( 'rest_api_init', array( $this, 'register_routes' ) );
  }
 
  public function update_password_permission() {
	return true;	// pathway
    if ( ! current_user_can( 'edit_posts' ) ) {
		return new WP_Error( '401', esc_html__( 'You do not have permissions to update data.', 'tp-pac' ), array( 'status' => 401, 'Uname' => $uname ) );
//		return new WP_Error( 'rest_forbidden', esc_html__( 'You do not have permissions to create/update data.', 'tp-pac' ), array( 'status' => 401 ) );
      }
      return true;
  }
 
  public function update_password( WP_REST_Request $request ) {
	$input = $request->get_params();
	$uname = $input['Uname'];
	$passold = $input['Passold'];
	$passnew = $input['Passnew'];
	
	// if ( $uname != 'adminhub' )
	if ( !username_exists($uname) )
		return new WP_Error( '404', esc_html__( 'Username not found.', 'tp-pac' ), array( 'Uname' => $uname ) );
		
	$userdata = get_user_by( 'login', $uname );
	// https://stackoverflow.com/questions/19677563/check-wordpress-hashed-password-with-plain-password
	if ( !wp_check_password( $passold, $userdata->user_pass, $userdata->ID ) )
		return new WP_Error( '406', esc_html__( 'Old password not matched.', 'tp-pac' ), array( 'Passold' => $passold ) );
		
	// https://stackoverflow.com/questions/5706075/php-wordpress-password-change-logging-me-out
	wp_set_password( $passnew, $userdata->ID );
	
    //setup the data to be passed on to wp_signon
    $user_data = array(
            'user_login'		=> $uname,
            'user_password'		=> $passnew,
            'remember'			=> false
        );

    // Sign them back in.
    $result = wp_signon( $user_data );

    if ( is_wp_error($result) ) {
		return new WP_Error( '501', esc_html__( 'Error updating password.', 'tp-pac' ), array( 'Passnew' => $passnew ) );
    } else {
		return new WP_REST_Response( array( 'code' => 200, 'message' => 'Password updated successfully.' ), 200 );
    }
  }
  
}
 
$my_tp_pac_server = new TP_PAC_Server();
$my_tp_pac_server->hook_rest_server();